\section*{Background : modern system architecture}
Before diving into the details of portability, it's useful to have a quick look at the architecture of modern systems.

\begin{figure}
\center{\includegraphics[scale=0.4]{41-port-together/figure1}}
\caption{Architecure of a modern system}
\label{figure1}
\end{figure}

Figure \ref{figure1} shows one typical system architecture. There is a CPU complex which interfaces using the frontside bus to the northbridge. The northbridge interfaces to the main memory subsystem, the PCI bus and the AGP. Most peripherals are directly or indirectly connected to the PCI bus. Exception is the graphics subsystem which has its own port the the northbridge, the AGP. This is due to the high bandwidth requirements of modern 3D programs. Another system architecture is shown in Figure \ref{figure2}. Here the main memory is connected directly to the CPU. The CPUs themselves are interconnected via Hypertransport, a relatively narrow but high speed interconnection technology. Peripherals are connected via PCI express. The PCI express lanes are connected to the system via a hypertransport PCI express bridge. PCI express is a link based interconnection technology using 1.2Gbit/s bidirectional lanes. Multiple lanes can be bundled together for increased bandwidth. In contrast to PCI, PCI express is not a bus. This offers advantages with regard to scalability, powermanagement and latency. It's interesting to see why modern interfaces move from parallel to serial. The main reason is performance. A parallel interface requires all the wires to be almost the same length. Put differently : the small differences in signal propagation times due to wirelength variations limit the clock speed of a parallel interface. However it became only recently possible to integrate the necessary electronics for serialization/deserialization on chips, which is why we didn't see this move earlier. We also saw a great increase in CPU clock frequency in the last years. Unfortunately I/O and memory interfaces did not follow this trend by the same amount. Bandwidth and latency did not improve by the same amount. This lead to the introduction of cache memories and burstmode transfers to hide the memory and I/O slowness.

\begin{figure}
\center{\includegraphics[scale=0.4]{41-port-together/figure2}}
\caption{Another system architecture}
\label{figure2}
\end{figure}

\section*{C language portability pitfalls}
The ANSI-C language standard defines a few rules with regard to types. Writing portable code means sticking to this rules and not assuming a particular size for a type, unless this is guaranteed by the standard.
In general C programs should use int as much as possible for simple integer computations, loop variables etc. In case you need a specific size (to implement a file format or a binary communication protocol), the ISO C99 types are prefered. Some operations like basic arithmetic or shifts might be more expensive on these types though.
Be aware of bitfields. They are particularly nasty because the ordering of the bitfields is architecture dependent. 
Newer gcc versions tend to catch more portability problems such as signed versus unsigned types etc. It's worthwhile to compile your code using a recent gcc version with the -Wall option to catch this sort of problems.

\section*{Endianess}
Endianess refers to the ordering of bytes in a multibyte 'object' like a 16,32 or 64 bit integer. There are basically 2 ways : little and big endian. Using little endian ordering, 0x12345678 will be represented as 0x78 0x56 0x34 0x12. In big endian ordering this would be 0x12 0x34 0x56 0x78. This is important any time programs interchange binary data. Examples are network protocols, file formats, ... The best way of coping with this is to have proper 'serializing' and 'deserializing' routines which handle conversion of the data between the internal and the external representation.

\section*{Alignment}
Alignment means a multibyte 'object' starts at an address which is a multiple of its size. Some RISC CPUs do not handle unaligned accesses in hardware (unlike IA32 for example which does handle an unaligned access transparently for software). Most RISC CPUs which  do not handle unaligned accesses in hardware, will generate a trap when an unaligned access is detected. This trap is generally handled by the kernel, which will handle the access. This obviously has significant performance impact. There are RISC CPUs which do not generate a trap, but basically ignore the lower address bits in case of an unaligned access. ARM is probably the most notable example of this kind of CPUs. Modern ARMs can actually generate a trap, but this feature is disabled for compatibility with older ARM CPUs.
Unaligned accesses are almost never atomic, even on CPUs which handle them in hardware. This is important when implementing RCU or other look free data exchange mechanisms.
In general it's best to avoid unaligned accesses as much as possible. In some cases the compiler can generate the right code for an unaligned access, but in many cases (particularly when using typecasts in C), it can not. In that case it might be necessary to copy the data to an aligned buffer first.

\section*{Memory organization}
Memory organization refers to the way the userland address space is generally used by executables. A few things to be aware of : stack ordering and variable number of arguments in C. Not all architectures have a downward growing stack as IA32 has. Most notable is PARISC.

\section*{Accessing peripherals}
Even though accessing peripherals is generally done by the kernel in a Debian Linux system, some userland programs also access peripherals. Most notably are probably the XFree86 and X.org X11 servers. Other examples include cdrecord and gphoto. There are generally 2 ways of accessing peripherals in a system. Either by directly writing to registers or memory of the peripheral, or by exchanging messages with the peripheral via eg USB, 1394, SCSI, ATAPI,... In the latter case the kernel generally cares about the transport of the data between the CPU / memory and the peripheral. This means most of the platform specific details are taken care of. Directly accessing a peripheral however is problematic with regard to portability. Inside the kernel most portability issues are dealt with by using special macros/functions to access peripheral registers. These macros/functions are however not available for userland programs. In general this means the userland program has to provide these abstractions itself. 

